/*
 * Copyright (c) 2017 SpaceToad and the BuildCraft team
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not
 * distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/
 */

package buildcraft.energy.container;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;

import buildcraft.lib.gui.ContainerBCTile;
import buildcraft.lib.gui.widget.WidgetFluidTank;

import buildcraft.energy.tile.TileEngineIron_BC8;

public class ContainerEngineIron_BC8 extends ContainerBCTile<TileEngineIron_BC8> {
    public final WidgetFluidTank widgetTankFuel;
    public final WidgetFluidTank widgetTankCoolant;
    public final WidgetFluidTank widgetTankResidue;

    public ContainerEngineIron_BC8(EntityPlayer player, TileEngineIron_BC8 engine) {
        super(player, engine);

        addFullPlayerInventory(95);

        widgetTankFuel = addWidget(new WidgetFluidTank(this, engine.tankFuel));
        widgetTankCoolant = addWidget(new WidgetFluidTank(this, engine.tankCoolant));
        widgetTankResidue = addWidget(new WidgetFluidTank(this, engine.tankResidue));
    }

    @Override
    public ItemStack func_82846_b(EntityPlayer player, int index) {
        // The only slots are player slots -- try to interact with all of the tanks

        if (!player.field_70170_p.field_72995_K) {
            Slot slot = field_75151_b.get(index);
            ItemStack stack = slot.func_75211_c();
            ItemStack original = stack.func_77946_l();
            stack = tile.tankFuel.transferStackToTank(this, stack);
            if (!ItemStack.func_77989_b(stack, original)) {
                slot.func_75215_d(stack);
                func_75142_b();
                return ItemStack.field_190927_a;
            }
            stack = tile.tankCoolant.transferStackToTank(this, stack);
            if (!ItemStack.func_77989_b(stack, original)) {
                slot.func_75215_d(stack);
                func_75142_b();
                return ItemStack.field_190927_a;
            }
            stack = tile.tankResidue.transferStackToTank(this, stack);
            if (!ItemStack.func_77989_b(stack, original)) {
                slot.func_75215_d(stack);
                func_75142_b();
                return ItemStack.field_190927_a;
            }
        }

        return super.func_82846_b(player, index);
    }
}
